pipeline {
  environment {
    image = "rex8662/php"
    dockerImage = ""
  }
  agent any
  stages {
    stage("Code Checkout") {
        steps {
            git branch: 'master',
            credentialsId: 'credential_gitlab_rosi',
            url: 'https://gitlab.com/rosi.achmad/awhds.git'
        }
    }
    stage('Code Quality') {
      steps {
        script {
          def scannerHome = tool 'sonar_scanner';
            withSonarQubeEnv("sonarqube") {
              sh "${tool("sonar_scanner")}/bin/sonar-scanner -Dsonar.projectName=awhds -Dsonar.projectVersion=$BUILD_NUMBER -Dsonar.projectKey=awhds -Dsonar.sources=. "
              }
            }
        }
    }
    stage('Quality Gate') {
    	steps {
    	  timeout(time: 1, unit: 'MINUTES') {
    		waitForQualityGate abortPipeline: true
    	  }
    	}
    }
    stage('Build image') {
      steps{
        script {
          dockerImage = docker.build image + ":$BUILD_NUMBER"
        }
      }
    }
    stage('Push Image') {
      steps{
        script {
          docker.withRegistry( '', 'dockerhub-id' ) {
            dockerImage.push()
          }
        }
      }
    }
    stage('Deploy to Kubernetes') {
      steps {
        kubernetesDeploy(configs: 'deployment.yaml', kubeconfigId: 'kube-config')
      }
    }
  }
}
